<template>
	<div
		class="card-container cursor-pointer shadow-10"
		@click="routerPush(`/pokemon/${pokemon.name}`)"
	>
		<div
			class="card-header row items-center justify-center"
			:class="`bg-${getTypeColor(pokemon.types[0].type.name)}`"
		>
			<img
				height="150px"
				width="150px"
				lazy
				class="q-my-md"
				:src="pokemon.image"
			/>
		</div>
		<div class="card-body row q-pa-sm">
			<primary-title :title="pokemon.name" />
			<div class="type row q-gutter-sm col-12">
				<q-chip
					:color="getTypeColor(type.type.name)"
					class="text-thin text-white"
					v-for="(type, typeIndex) in pokemon.types"
					:key="`${typeIndex}A`"
					>{{ type.type.name }}</q-chip
				>
			</div>

			<div class="go-corner">
				<div class="go-arrow">→</div>
			</div>
		</div>
	</div>
</template>

<script>
	import { routeManage } from "../mixins/commonMixins";
	import { typeColor } from "../mixins/colorMixins";
	import primaryTitle from "../typography/primary-title.vue";

	export default {
		name: "CardPreview",
		mixins: [typeColor, routeManage],
		components: { primaryTitle },
		props: {
			pokemon: {
				type: Object,
				required: true,
			},
		},
	};
</script>

<style soped lang="scss">
	.card-container {
		transition: 0.25s;
		z-index: 1;
		&:hover {
			transform: scale(0.98, 0.98);
			outline: none;
			border-color: #9ecaed;
			box-shadow: 0 0 15px #9ecaed;
		}

		&:hover > .card-body {
			span {
				transition: all 0.3s ease-out;
				color: #ffffff;
			}
		}

		&:hover:before > .card-body {
			transform: scale(21);
		}
		min-height: 100px;
		min-height: 200px;
		border-radius: 15px;
		overflow: hidden;
		.card-header {
			min-height: 15rem;
		}

		.card-body {
			background-color: #f2f8f9;
			z-index: -1;
			position: relative;
			.go-corner {
				display: flex;
				align-items: center;
				justify-content: center;
				position: absolute;
				width: 32px;
				height: 32px;
				overflow: hidden;
				top: 0;
				right: 0;
				background-color: #fa5700;
				border-radius: 0 0 0 32px;
			}

			&:hover:before {
				transform: scale(5);
			}
			.go-arrow {
				margin-top: -4px;
				margin-right: -4px;
				color: white;
				font-family: courier, sans;
			}
			&:before {
				content: "";
				position: absolute;
				z-index: -1;
				top: -16px;
				right: -16px;
				background: #fa5700;
				height: 32px;
				width: 32px;
				border-radius: 32px;
				transform: scale(1);
				transform-origin: 50% 50%;
				transition: transform 0.25s ease-out;
			}
		}
	}
</style>
